<?php
//////////////////////////////////////////////////////////////////////////////////////////////////////
// L'encrier 1.2.0                                                                                  //
// Copyright (C) 2002-2004 Sylvain Eliade <sylvain@journalintime.com>                               //
// This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike License.   //
// To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/1.0/          //
// or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.    //
// Francais (brouillon): http://creativecommons.org/projects/international/fr/translated-license    //
//////////////////////////////////////////////////////////////////////////////////////////////////////

// Ajout des messages dans les forums
// Nota: curieusement la redirection par 404 ne permet pas de rcuprer des requtes POST
// v0.2.O

if(empty($_POST))
{
	die("404");
}

function display_page($title, $content)
{
    echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
        <title>'.$title.'</title>
        <style type="text/css">
        body { font-size: 12px; font-family: Arial, Helvetica, sans-serif; }
        #page { margin-left: auto; margin-right: auto; width: 500px; }
        dt { font-weight: bold; }
        dd { margin: 1em; padding: 0.5em; border: 1px solid #ccc; }
        input[type=submit] { font-weight: bold; }
        </style>
    </head>

    <body>
    <div id="page">
    '.$content.'
    </div>
    </body>
    </html>
    ';
}

@session_start();
include_once("classes/config.inc.php");

if(!empty($_SESSION['msg']) && !empty($_POST['confirm']))
{
    include_once("classes/journal.php");
    include_once("classes/forum.php");
    include_once("classes/cache.php");

    $msg = $_SESSION['msg'];

    $urls = preg_match_all('!http://!', $msg['texte'], $match, PREG_SET_ORDER);
    if (@count($match) > 3)
    {
        die('Trop de liens dans le message.');
    }

    $journal = new journal();
    $journal->infos = $journal->infos($msg['journal']);

    $forum = new forum();
    $forum->chemin = "datas/";
    $forum->err['stop'] = "non";

    // Si on peux pas rcuprer le journal c'est qu'il n'existe pas
    if(!$journal->infos) { die('404'); }

    if(empty($msg['parent']))
        $msg['parent'] = "0";

    $id = $forum->add($journal->infos['id'],array(
            "nom"   =>  $msg['nom'],
            "email" =>  $msg['email'],
            "titre" =>  $msg['titre'],
            "texte" =>  $msg['texte'],
            "parent"=>  $msg['parent']));

    if(!$id)
        $erreur = $forum->erreur;

    if($erreur)
    {
        $content ='
    <form method="post" action="/addmessage.php?login='.$journal->infos['id'].'">
    <h3>Erreur dans l\'ajout du message</h3>
    <p style="color: red;">'.$erreur.'</p>
    <p>Corrigez l\'erreur si possible et renvoyez le formulaire.</p>
    <dl>
    <dl>
      <dt><label for="fnom">Nom</label> (facultatif)</dt>
      <dd><input type="text" name="nom" id="fnom" value="'.str2html($msg['nom']).'" /></dd>
      <dt><label for="fmail">E-Mail</label> (facultatif)</dt>
      <dd><input type="text" name="email" id="fmail" value="'.str2html($msg['email']).'" /></dd>
      <dt><label for="ftitre">Titre</label>'.(($msg['parent'] == "0") ? '' : ' (facultatif)').'</dt>
      <dd><input type="text" name="titre" id="ftitre" value="'.str2html($msg['titre']).'" /></dd>
      <dt><label for="ftexte">Texte</label></dt>
      <dd><textarea name="texte" id="ftexte" cols="40" rows="20">'.str2html($msg['texte']).'</textarea></dd>
    </dl>
    <p class="tip">
      Nota: Le code HTML sera affich comme du texte, les adresses internet seront converties automatiquement.
    </p>
    <p class="submit"><input type="hidden" name="parent" value="'.str2html($msg['parent']).'" /><input type="submit" name="post" value="Poster" /></p>
    </form>
    ';
        display_page('Forum - '.$journal->infos['id'], $content);
        exit;
    }

    unset($_SESSION['msg']);

    $datas = $forum->getPostLight($journal->infos['id'], $id);
    header("location: ".id2url($journal->infos['id'])."forum/".$datas['uri']);
    exit;
}
else
{
    $msg = array('texte' => $_POST['texte'], 'titre' => $_POST['titre'],
        'nom' => $_POST['nom'], 'email' => $_POST['email'], 'journal' => $_GET['login'],
        'parent' => $_POST['parent']);
    $_SESSION['msg'] = $msg;

    $content = '<h3>Prvisualisation du message</h3>
        <p>Vrifiez que le message ci-dessous correspond  ce que vous dsirez envoyer et cliquez sur Confirmer ou sur Annuler pour revenir  l\'dition du message.</p>
        <dl>
            <dt>Nom</dt>
            <dd>'.(empty($msg['nom']) ? 'anonyme' : str2html($msg['nom'])).'</dd>
            <dt>eMail</dt>
            <dd>'.(empty($msg['email']) ? 'Non renseign' : str2html($msg['email'])).'</dd>
            <dt>Titre</dt>
            <dd>'.(empty($msg['titre']) ? 'Non renseign' : str2html($msg['titre'])).'</dd>
            <dt>Message</dt>
            <dd>'.nl2br(str2html($msg['texte'])).'</dd>
        </dl>
        <form method="post" action="/addmessage.php?login='.$msg['journal'].'">
        <input type="submit" name="confirm" value="Confimer" /> &nbsp;
        <input type="button" value="Annuler" onclick="history.back();" />
        </form>';

    display_page('Forum - '.$msg['journal'], $content);
    exit;
}

?>